package com.gic.enterprise.utils;

import com.alibaba.fastjson.JSON;
import com.gic.commons.util.ToolUtil;
import com.gic.commons.web.RequestThreadLocal;
import com.gic.commons.web.ResponseThreadLocal;
import com.gic.commons.web.ex.ErrorEnum;
import com.gic.commons.web.ex.GicApiException;
import com.gic.enterprise.constants.Constants;
import com.gic.redis.data.util.RedisUtil;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import java.util.concurrent.TimeUnit;

public class UserDetailUtils {
    public static UserDetail getUserDetail(){
        HttpServletRequest request = RequestThreadLocal.get();
        if (request != null){
            Cookie[] cookies = request.getCookies();
            String token = null;
            for (Cookie cookie : cookies) {
                if (Constants.USER_TOKEN.equals(cookie.getName())) {
                    token = cookie.getValue();
                    break;
                }
            }
            String key = Constants.TOKEN_KEY+token;
            Object cache = RedisUtil.getCache(key);
            if(cache != null){
                return (UserDetail) cache;
            }
        }
        return new UserDetail();
    }

    public static void setUserDetail(UserDetail userDetail){
        String uuId = ToolUtil.randomUUID();
        String key = Constants.TOKEN_KEY+uuId;
        RedisUtil.setCache(key, userDetail, 1l, TimeUnit.HOURS);
        Cookie cookie = new Cookie(Constants.USER_TOKEN, uuId);
        cookie.setPath("/");
        ResponseThreadLocal.get().addCookie(cookie);
    }
}
